Index: GTP/trunk/App/Demos/Illum/Shark3D/version164x12u/CleanTheLab/bin/res/levelutil/shader/ordinary.s3d_shader_run
===================================================================
--- GTP/trunk/App/Demos/Illum/Shark3D/version164x12u/CleanTheLab/bin/res/levelutil/shader/ordinary.s3d_shader_run	(revision 2499)
+++ GTP/trunk/App/Demos/Illum/Shark3D/version164x12u/CleanTheLab/bin/res/levelutil/shader/ordinary.s3d_shader_run	(revision 2503)
@@ -2022,4 +2190,136 @@
             {
                 env "shaderenv"
+                methods "light_method"
+                rank 99999
+                insp_ident "showwire"
+                cull_mode "back"
+                depth_test "less_equal"
+                depth_write 1
+                use_vertex_bone_wgh 1
+                use_vertex_bone_subscr 1
+                use_vertex_point 1
+                use_vertex_normal 1
+                mesh_var "mesh"
+                texchan_var_array "tex0" "normalmap"
+                tex_attr_var_array "attr0" "tangentu" "tangentv"
+                attrmat_var_array ""
+                blend_col_src_fac "one"
+                blend_col_dest_fac "inv_src_col"
+                lightarray_var ""
+                shaderprog_ident
+                    "levelutil/shader/prog/bump.s3d_shaderprog_run"
+                shaderprog_param_array
+                {
+                    src_var "light_cenrange"
+                    dest_progvar "prog_light_cenrange"
+                }
+                {
+                    src_var "light_ambient"
+                    dest_progvar "prog_light_ambient"
+                }
+                {
+                    src_var "light_diffuse"
+                    dest_progvar "prog_light_diffuse"
+                }
+                {
+                    src_var "light_specular"
+                    dest_progvar "prog_light_specular"
+                }
+            }
+        }
+        {
+            ident "eng_shader_std.paintmesh"
+            param
+            {
+                env "shaderenv"
+                methods "lightmild_method"
+                rank 99999
+                insp_ident "showwire"
+                cull_mode "back"
+                depth_test "less_equal"
+                depth_write 1
+                use_vertex_bone_wgh 1
+                use_vertex_bone_subscr 1
+                use_vertex_point 1
+                use_vertex_normal 1
+                mesh_var "mesh"
+                texchan_var_array "tex0" "normalmap"
+                tex_attr_var_array "attr0" "tangentu" "tangentv"
+                attrmat_var_array ""
+                blend_col_src_fac "one"
+                blend_col_dest_fac "inv_src_col"
+                lightarray_var ""
+                shaderprog_ident
+                    "levelutil/shader/prog/bump_mild.s3d_shaderprog_run"
+                shaderprog_param_array
+                {
+                    src_var "light_cenrange"
+                    dest_progvar "prog_light_cenrange"
+                }
+                {
+                    src_var "light_ambient"
+                    dest_progvar "prog_light_ambient"
+                }
+                {
+                    src_var "light_diffuse"
+                    dest_progvar "prog_light_diffuse"
+                }
+                {
+                    src_var "light_specular"
+                    dest_progvar "prog_light_specular"
+                }
+            }
+        }
+        {
+            ident "eng_shader_std.paintmesh"
+            param
+            {
+                env "shaderenv"
+                methods "lightbright_method"
+                rank 12000
+                insp_ident "showwire"
+                cull_mode "back"
+                depth_test "less_equal"
+                depth_write 0
+                mesh_var "mesh"
+                texchan_var_array "tex0" "normalmap" "light_brighttex"
+                tex_attr_var_array "attr0" "tangentu" "tangentv"
+                attrmat_var_array "" "" ""
+                blend_col_src_fac "one"
+                blend_col_dest_fac "inv_src_col"
+                use_vertex_bone_wgh 1
+                use_vertex_bone_subscr 1
+                use_vertex_point 1
+                use_vertex_normal 1
+                shaderprog_ident
+                    "levelutil/shader/prog/bump_bright.s3d_shaderprog_run"
+                shaderprog_param_array
+                {
+                    src_var "light_cenrange"
+                    dest_progvar "prog_light_cenrange"
+                }
+                {
+                    src_var "light_ambient"
+                    dest_progvar "prog_light_ambient"
+                }
+                {
+                    src_var "light_diffuse"
+                    dest_progvar "prog_light_diffuse"
+                }
+                {
+                    src_var "light_specular"
+                    dest_progvar "prog_light_specular"
+                }
+                {
+                    src_var "light_brightmat"
+                    dest_progvar "prog_light_brightmat"
+                }
+            }
+        }
+        {
+            ident "eng_shader_std.paintmesh"
+            param
+            {
+                env "shaderenv"
                 methods "lightshmap_method"
                 rank 99999
@@ -2136,177 +2436,4 @@
         }
         {
-            ident "gtp_shader.createtex"
-            param
-            {
-                env "shaderenv"
-                methods "init_method"
-                texchan_var "envmap0"
-                width 32
-                height 32
-                texprop_rendertarget 1
-                texprop_cube 1
-                texprop_float 0
-                texprop_comp 4
-                texprop_bitspercomp 8
-                samplermode_clamp 0
-                samplermode_filter 1
-            }
-        }
-        {
-            ident "gtp_shader.envmap"
-            param
-            {
-                env "shaderenv"
-                methods "main_method"
-                rank -90000
-                max_ext 256
-                max_recursion 2
-                ext_dist_scale 20.0
-                proj_neg_z 0.1
-                proj_pos_z 100.0
-                enum_trigger "mirror_trigger"
-                destprop_antialias 0
-                mesh_var "mesh"
-                update_interval 6
-                update_all_face 0
-                start_frame 1
-                last_center_var "lastCenter"
-                world_space 1
-                dest_array
-                {
-                    from_var "envmap0"
-                    to_var "envmap0"
-                    texprop_restrusage 0
-                    texprop_depth 0
-                    texprop_comp 3
-                    texprop_float 0
-                    samplermode_filter 0
-                    samplermode_clamp 1
-                }
-            }
-        }
-        {
-            ident "gtp_shader.createtex"
-            param
-            {
-                env "shaderenv"
-                methods "init_method"
-                texchan_var "dist"
-                width 128
-                height 128
-                texprop_rendertarget 1
-                texprop_cube 1
-                texprop_float 1
-                texprop_comp 2
-                texprop_bitspercomp 16
-                samplermode_clamp 0
-                samplermode_filter 1
-            }
-        }
-        {
-            ident "gtp_shader.envmap"
-            param
-            {
-                env "shaderenv"
-                methods "main_method"
-                rank -90000
-                max_ext 128
-                max_recursion 1
-                ext_dist_scale 20.0
-                proj_neg_z 0.1
-                proj_pos_z 100.0
-                enum_trigger "gtp_distance_impostor_trigger"
-                destprop_antialias 0
-                mesh_var "mesh"
-                update_interval 6
-                update_all_face 1
-                start_frame 1
-                last_center_var "lastCenter"
-                world_space 1
-                dest_array
-                {
-                    from_var "dist"
-                    to_var "dist"
-                    texprop_restrusage 0
-                    texprop_depth 0
-                    texprop_comp 1
-                    texprop_float 1
-                    samplermode_filter 0
-                    samplermode_clamp 1
-                }
-            }
-        }
-        {
-            ident "gtp_shader.worldmat"
-            param
-            {
-                env "shaderenv"
-                methods "main_method"
-                worldmat_var "worldMat"
-            }
-        }
-        {
-            ident "gtp_shader.worldmat"
-            param
-            {
-                env "shaderenv"
-                methods "main_method"
-                worldmat_var "worldMatIT"
-                inverse 1
-                transpose 1
-            }
-        }
-        {
-            ident "eng_shader_std.constvec"
-            param
-            {
-                env "shaderenv"
-                methods "init_method"
-                val_var "Fresnel"
-                val 0.95 0.63 0.54 1.0
-            }
-        }
-        {
-            ident "eng_shader_std.paintmesh"
-            param
-            {
-                env "shaderenv"
-                methods "main_method"
-                rank 12000
-                insp_ident "insp_shader_mesh"
-                cull_mode "back"
-                depth_test "less_equal"
-                depth_write 0
-                mesh_var "mesh"
-                texchan_var_array "envmap0" "dist"
-                tex_attr_var_array "attr0"
-                attrmat_var_array ""
-                use_vertex_bone_wgh 1
-                use_vertex_bone_subscr 1
-                use_vertex_point 1
-                use_vertex_normal 1
-                use_vertex_coloralpha 0
-                shaderprog_ident
-                    "levelutil/shader/prog/gtp_envmap_metal.s3d_shaderprog_run"
-                shaderprog_param_array
-                {
-                    src_var "lastCenter"
-                    dest_progvar "lastCenter"
-                }
-                {
-                    src_var "worldMat"
-                    dest_progvar "worldMat"
-                }
-                {
-                    src_var "worldMatIT"
-                    dest_progvar "worldMatIT"
-                }
-                {
-                    src_var "Fresnel"
-                    dest_progvar "Fresnel"
-                }
-            }
-        }
-        {
             ident "eng_shader_std.paintmesh"
             param
@@ -2333,8 +2460,55 @@
             }
         }
+        {
+            ident "gtp_shader.worldmat"
+            param
+            {
+                env "shaderenv"
+                methods "caustic_recieve_method"
+                worldmat_var "worldMat"
+            }
+        }
+        {
+            ident "eng_shader_std.paintmesh"
+            param
+            {
+                env "shaderenv"
+                methods "caustic_recieve_method"
+                rank 14000
+                insp_ident "insp_shader_mesh"
+                cull_mode "back"
+                depth_test "less_equal"
+                depth_write 1
+                depth_bias_overlay 1
+                depth_bias_offs 1
+                mesh_var "mesh"
+                texchan_var_array "cauCubeMap"
+                tex_attr_var_array "attr0"
+                attrmat_var_array ""
+                use_vertex_bone_wgh 1
+                use_vertex_bone_subscr 1
+                use_vertex_point 1
+                blend_col_dest_fac "one"
+                blend_col_src_fac "one"
+                blend_col_op "src_plus_dest"
+                color 1.0 1.0 1.0
+                shaderprog_ident
+                    "levelutil/shader/prog/gtp_caustic_recieve.s3d_shaderprog_"
+                    & "run"
+                shaderprog_param_array
+                {
+                    src_var "cauCubeLastCenter"
+                    dest_progvar "lastCenter"
+                }
+                {
+                    src_var "worldMat"
+                    dest_progvar "worldMat"
+                }
+            }
+        }
     }
 }
 {
-    name "ordinary_alu"
+    name "ordinary_copper"
     ident "eng_shader_std.group"
     param
@@ -2773,6 +2947,6 @@
                 methods "init_method"
                 texchan_var "envmap0"
-                width 128
-                height 128
+                width 32
+                height 32
                 texprop_rendertarget 1
                 texprop_cube 1
@@ -2799,6 +2973,6 @@
                 destprop_antialias 0
                 mesh_var "mesh"
-                update_interval 1
-                update_all_face 1
+                update_interval 6
+                update_all_face 0
                 start_frame 1
                 last_center_var "lastCenter"
@@ -2850,5 +3024,5 @@
                 destprop_antialias 0
                 mesh_var "mesh"
-                update_interval 1
+                update_interval 6
                 update_all_face 1
                 start_frame 1
@@ -2895,5 +3069,5 @@
                 methods "init_method"
                 val_var "Fresnel"
-                val 0.9 0.92 0.92 1.0
+                val 0.95 0.63 0.54 1.0
             }
         }
@@ -2967,5 +3141,5 @@
 }
 {
-    name "caustic_caster"
+    name "ordinary_alu"
     ident "eng_shader_std.group"
     param
@@ -2981,9 +3155,27 @@
                 methods "init_method"
                 mesh_var "mesh"
+                texchan_var_array "tex0" "normalmap"
+                tex_attr_var_array "attr0"
+                usage "render"
+                tangentu_attr_var "tangentu"
+                tangentv_attr_var "tangentv"
+                insp_ident "showmesh"
+                insp_rank 80000
+                insp_color 1.0 1.0 0.0
+            }
+        }
+        {
+            ident "eng_shader_std.modelmesh"
+            param
+            {
+                env "shaderenv"
+                methods "init_method"
+                usage "shvol_occl"
+                mesh_var "mesh_shvol_occl"
                 texchan_var_array
                 tex_attr_var_array
-                usage "render"
-                tangentu_attr_var
-                tangentv_attr_var
+                insp_ident "showocclmesh"
+                insp_rank 80000
+                insp_color 0.5 1.0 0.0
             }
         }
@@ -2994,5 +3186,5 @@
                 env "shaderenv"
                 mesh_var_array "mesh"
-                insp_ident "insp_shader_bound"
+                insp_ident "showbound"
                 insp_rank 80000
                 insp_color 1.0 0.0 0.0
@@ -3007,6 +3199,10 @@
                 }
                 {
-                    triggers "caustic_cast_trigger"
-                    method "caustic_cast_method"
+                    triggers "gen_shmap_trigger"
+                    method "gen_shmap_method"
+                }
+                {
+                    triggers "light_trigger"
+                    method "light_method"
                     param_array
                     {
@@ -3015,18 +3211,362 @@
                     }
                     {
-                        src_extvar "recievers"
-                        dest_var "recievers"
-                    }
-                }
-            }
-        }
-        {
-            ident "eng_shader_std.constvec"
-            param
-            {
-                env "shaderenv"
-                methods "init_method"
-                val_var "lastCenter"
-                val 0.0 0.0 0.0 1.0
+                        src_extvar "ext_light_ambient"
+                        dest_var "light_ambient"
+                    }
+                    {
+                        src_extvar "ext_light_diffuse"
+                        dest_var "light_diffuse"
+                    }
+                    {
+                        src_extvar "ext_light_specular"
+                        dest_var "light_specular"
+                    }
+                }
+                {
+                    triggers "lightmild_trigger"
+                    method "lightmild_method"
+                    param_array
+                    {
+                        src_extvar "ext_light_cenrange"
+                        dest_var "light_cenrange"
+                    }
+                    {
+                        src_extvar "ext_light_ambient"
+                        dest_var "light_ambient"
+                    }
+                    {
+                        src_extvar "ext_light_diffuse"
+                        dest_var "light_diffuse"
+                    }
+                    {
+                        src_extvar "ext_light_specular"
+                        dest_var "light_specular"
+                    }
+                }
+                {
+                    triggers "lightbright_trigger"
+                    method "lightbright_method"
+                    param_array
+                    {
+                        src_extvar "ext_light_cenrange"
+                        dest_var "light_cenrange"
+                    }
+                    {
+                        src_extvar "ext_light_ambient"
+                        dest_var "light_ambient"
+                    }
+                    {
+                        src_extvar "ext_light_diffuse"
+                        dest_var "light_diffuse"
+                    }
+                    {
+                        src_extvar "ext_light_specular"
+                        dest_var "light_specular"
+                    }
+                    {
+                        src_extvar "ext_light_brighttex"
+                        dest_var "light_brighttex"
+                    }
+                    {
+                        src_extvar "ext_light_brightmat"
+                        dest_var "light_brightmat"
+                    }
+                }
+                {
+                    triggers "lightshmap_trigger"
+                    method "lightshmap_method"
+                    param_array
+                    {
+                        src_extvar "ext_light_cenrange"
+                        dest_var "light_cenrange"
+                    }
+                    {
+                        src_extvar "ext_light_ambient"
+                        dest_var "light_ambient"
+                    }
+                    {
+                        src_extvar "ext_light_diffuse"
+                        dest_var "light_diffuse"
+                    }
+                    {
+                        src_extvar "ext_light_specular"
+                        dest_var "light_specular"
+                    }
+                    {
+                        src_extvar "ext_light_projmat"
+                        dest_var "light_projmat"
+                    }
+                    {
+                        src_extvar "ext_light_shmapmat"
+                        dest_var "light_shmapmat"
+                    }
+                    {
+                        src_extvar "ext_light_projtex"
+                        dest_var "light_projtex"
+                    }
+                    {
+                        src_extvar "ext_light_shmap"
+                        dest_var "light_shmap"
+                    }
+                }
+                {
+                    triggers "gen_brightmap_for_softshmap_trigger"
+                    method "gen_brightmap_for_softshmap_method"
+                    param_array
+                    {
+                        src_extvar "ext_light_intens"
+                        dest_var "light_intens"
+                    }
+                    {
+                        src_extvar "ext_light_projmat"
+                        dest_var "light_projmat"
+                    }
+                    {
+                        src_extvar "ext_light_shmapmat"
+                        dest_var "light_shmapmat"
+                    }
+                    {
+                        src_extvar "ext_light_projtex"
+                        dest_var "light_projtex"
+                    }
+                    {
+                        src_extvar "ext_light_shmap"
+                        dest_var "light_shmap"
+                    }
+                }
+                {
+                    triggers "gen_brightclear_trigger"
+                    method "gen_brightclear_method"
+                }
+            }
+        }
+        {
+            ident "eng_shader_std.meshenter"
+            param
+            {
+                env "shaderenv"
+                mesh_var_array "mesh_shvol_occl"
+                insp_ident "showbound"
+                insp_rank 80000
+                insp_color 1.0 0.0 0.0
+                enter_array
+                {
+                    triggers "shvol_mark_trigger"
+                    method "shvol_mark_method"
+                    param_array
+                    {
+                        src_extvar "ext_light_cenrange"
+                        dest_var "light_cenrange"
+                    }
+                    {
+                        src_extvar "ext_light_shvolparam"
+                        dest_var "light_shvolparam"
+                    }
+                }
+            }
+        }
+        {
+            ident "eng_shader_shvol.occluder"
+            param
+            {
+                env "shaderenv"
+                methods "shvol_mark_method"
+                reverse_rank 90010
+                nonreverse_rank 90000
+                insp_ident "showocclwire"
+                rel_gap 0.01
+                backface 0
+                mesh_var "mesh_shvol_occl"
+                cenrange_var "light_cenrange"
+                shvolparam_var "light_shvolparam"
+                extrude_var "light_extrude"
+                strict_shaderprog_ident
+                    "levelutil/shader/prog/gen_shvol_strict.s3d_shaderprog_run"
+                strict_shaderprog_param_array
+                {
+                    src_var "light_cenrange"
+                    dest_progvar "prog_light_cenrange"
+                }
+                {
+                    src_var "light_extrude"
+                    dest_progvar "prog_light_extrude"
+                }
+                quick_shaderprog_ident
+                    "levelutil/shader/prog/gen_shvol_quick.s3d_shaderprog_run"
+                quick_shaderprog_param_array
+                {
+                    src_var "light_cenrange"
+                    dest_progvar "prog_light_cenrange"
+                }
+                {
+                    src_var "light_extrude"
+                    dest_progvar "prog_light_extrude"
+                }
+            }
+        }
+        {
+            ident "eng_shader_std.paintmesh"
+            param
+            {
+                env "shaderenv"
+                rank 99999
+                cull_mode "back"
+                depth_test "less_equal"
+                depth_write 1
+                methods "gen_shmap_method"
+                mesh_var "mesh"
+                texchan_var_array
+                tex_attr_var_array
+                attrmat_var_array ""
+                use_vertex_bone_wgh 1
+                use_vertex_bone_subscr 1
+                use_vertex_point 1
+                shaderprog_ident
+                    "levelutil/shader/prog/gen_shmap.s3d_shaderprog_run"
+                shaderprog_param_array
+            }
+        }
+        {
+            ident "eng_shader_std.paintmesh"
+            param
+            {
+                env "shaderenv"
+                methods "main_method"
+                rank 12000
+                insp_ident "showwire"
+                cull_mode "back"
+                depth_test "less_equal"
+                depth_write 1
+                use_vertex_bone_wgh 1
+                use_vertex_bone_subscr 1
+                use_vertex_point 1
+                use_vertex_normal 0
+                color 0.0 0.0 0.0
+                mesh_var "mesh"
+                texchan_var_array
+                tex_attr_var_array
+                attrmat_var_array
+                lightarray_var ""
+                shaderprog_ident
+                    "levelutil/shader/prog/plain_point.s3d_shaderprog_run"
+                shaderprog_param_array
+            }
+        }
+        {
+            ident "eng_shader_std.paintmesh"
+            param
+            {
+                env "shaderenv"
+                methods "lightshmap_method"
+                rank 99999
+                insp_ident "showwire"
+                cull_mode "back"
+                depth_test "less_equal"
+                depth_write 0
+                use_vertex_bone_wgh 1
+                use_vertex_bone_subscr 1
+                use_vertex_point 1
+                use_vertex_normal 1
+                mesh_var "mesh"
+                texchan_var_array "tex0" "normalmap" "light_projtex"
+                    "light_shmap"
+                tex_attr_var_array "attr0" "tangentu" "tangentv"
+                attrmat_var_array ""
+                blend_col_src_fac "one"
+                blend_col_dest_fac "inv_src_col"
+                lightarray_var ""
+                shaderprog_ident
+                    "levelutil/shader/prog/bump_shmap.s3d_shaderprog_run"
+                shaderprog_param_array
+                {
+                    src_var "light_cenrange"
+                    dest_progvar "prog_light_cenrange"
+                }
+                {
+                    src_var "light_ambient"
+                    dest_progvar "prog_light_ambient"
+                }
+                {
+                    src_var "light_diffuse"
+                    dest_progvar "prog_light_diffuse"
+                }
+                {
+                    src_var "light_specular"
+                    dest_progvar "prog_light_specular"
+                }
+                {
+                    src_var "light_projmat"
+                    dest_progvar "prog_light_projmat"
+                }
+                {
+                    src_var "light_shmapmat"
+                    dest_progvar "prog_light_shmapmat"
+                }
+            }
+        }
+        {
+            ident "eng_shader_std.paintmesh"
+            param
+            {
+                env "shaderenv"
+                methods "gen_brightmap_for_softshmap_method"
+                rank 99999
+                cull_mode "back"
+                depth_test "less_equal"
+                depth_write 0
+                use_vertex_bone_wgh 1
+                use_vertex_bone_subscr 1
+                use_vertex_point 1
+                use_vertex_normal 1
+                mesh_var "mesh"
+                texchan_var_array "light_projtex" "light_shmap"
+                tex_attr_var_array ""
+                attrmat_var_array ""
+                blend_col_src_fac "one"
+                blend_col_dest_fac "inv_src_col"
+                lightarray_var ""
+                shaderprog_ident
+                    "levelutil/shader/prog/gen_brightmap_for_softshmap.s3d_sha"
+                    & "derprog_run"
+                shaderprog_param_array
+                {
+                    src_var "light_intens"
+                    dest_progvar "prog_light_intens"
+                }
+                {
+                    src_var "light_projmat"
+                    dest_progvar "prog_light_projmat"
+                }
+                {
+                    src_var "light_shmapmat"
+                    dest_progvar "prog_light_shmapmat"
+                }
+            }
+        }
+        {
+            ident "eng_shader_std.paintmesh"
+            param
+            {
+                env "shaderenv"
+                methods "gen_brightclear_method"
+                rank 12000
+                cull_mode "back"
+                depth_test "less_equal"
+                depth_write 1
+                mesh_var "mesh"
+                texchan_var_array
+                tex_attr_var_array
+                attrmat_var_array
+                fog_enabled 0
+                blend_col_src_fac "one"
+                blend_col_dest_fac "zero"
+                color 0.0 0.0 0.0
+                alpha 0.0
+                use_vertex_bone_wgh 1
+                use_vertex_bone_subscr 1
+                use_vertex_point 1
+                shaderprog_ident
+                    "levelutil/shader/prog/gen_brightclear.s3d_shaderprog_run"
+                shaderprog_param_array
             }
         }
@@ -3055,5 +3595,5 @@
                 env "shaderenv"
                 methods "main_method"
-                rank -89500
+                rank -90000
                 max_ext 256
                 max_recursion 2
@@ -3064,7 +3604,7 @@
                 destprop_antialias 0
                 mesh_var "mesh"
-                update_interval 6
-                update_all_face 0
-                start_frame 0
+                update_interval 1
+                update_all_face 1
+                start_frame 1
                 last_center_var "lastCenter"
                 world_space 1
